Index: c/src/lib/libbsp/powerpc/mvme5500/pci/pci.c
===================================================================
--- c/src/lib/libbsp/powerpc/mvme5500/pci/pci.c	(revision e1be2b30ad3b43c28cba087614a6ebca6356445e)
+++ c/src/lib/libbsp/powerpc/mvme5500/pci/pci.c	(revision d7196bfd6696be61880fff7db8ca4de044c30748)
@@ -17,9 +17,9 @@
  *
  *  Copyright 2004, Brookhaven National Laboratory and
- *                  Shuchen K. Feng, <feng1@bnl.gov>, 2004
- *   - modified and added support for MVME5500 board
- *   - added 2nd PCI support for the mvme5500/GT64260 PCI bridge
- *   - added bus support for the expansion of PMCSpan, thanks to 
- *     Peter Dufault (dufault@hda.com) for inputs.
+ *                  Shuchen K. Feng, <feng1@bnl.gov>, 2004, 2008
+ *   
+ *   - to be consistent with the original pci.c written by Eric Valette
+ *   - added 2nd PCI support for discovery based PCI bridge (e.g. mvme5500/mvme6100)
+ *   - added bus support for the expansion of PMCSpan as per request by Peter
  */
 #define PCI_MAIN
@@ -28,7 +28,9 @@
 #include <rtems/bspIo.h>	    /* printk */
 
+#include <bsp/irq.h>
 #include <bsp/pci.h>
 #include <bsp/gtreg.h>
 #include <bsp/gtpcireg.h> 
+#include <bsp.h>
 
 #include <stdio.h>
@@ -36,5 +38,5 @@
 
 #define PCI_DEBUG 0
-#define PCI_PRINT 0
+#define PCI_PRINT 1
 
 /* allow for overriding these definitions */
@@ -57,8 +59,22 @@
 #define HOSTBRIDGET_ERROR               0xf0000000
 
-/* define a shortcut */
-#define pci	BSP_pci_configuration
-
-static int		  numPCIDevs=0;
+#define GT64x60_PCI_CONFIG_ADDR         GT64x60_REG_BASE + PCI_CONFIG_ADDR
+#define GT64x60_PCI_CONFIG_DATA         GT64x60_REG_BASE + PCI_CONFIG_DATA
+
+#define GT64x60_PCI1_CONFIG_ADDR        GT64x60_REG_BASE + PCI1_CONFIG_ADDR
+#define GT64x60_PCI1_CONFIG_DATA        GT64x60_REG_BASE + PCI1_CONFIG_DATA
+
+static int      numPCIDevs=0;
+static DiscoveryChipVersion BSP_sysControllerVersion = 0;
+static BSP_VMEchipTypes BSP_VMEinterface = 0;
+static pci_config BSP_pci[2]={
+  {(volatile unsigned char*) (GT64x60_PCI_CONFIG_ADDR),
+   (volatile unsigned char*) (GT64x60_PCI_CONFIG_DATA),
+   0 /* defined at BSP_pci_configuration */},
+  {(volatile unsigned char*) (GT64x60_PCI1_CONFIG_ADDR),
+   (volatile unsigned char*) (GT64x60_PCI1_CONFIG_DATA),
+   0 /* defined at BSP_pci_configuration */}
+};
+
 extern void pci_interface();
 
@@ -67,5 +83,5 @@
  */
 #define pciConfigPack(bus,dev,func,offset)\
-(((func&7)<<8)|((dev&0x1f )<<11)|(( bus&0xff)<<16)|(offset&0xfc))|0x80000000
+((offset&~3)<<24)|(PCI_DEVFN(dev,func)<<16)|(bus<<8)|0x80
 
 /*
@@ -76,42 +92,34 @@
 /* Please note that PCI0 and PCI1 does not correlate with the busNum 0 and 1.
  */
-static int direct_pci_read_config_byte(unsigned char bus,unsigned char dev,unsigned char func,
+static int indirect_pci_read_config_byte(unsigned char bus,unsigned char dev,unsigned char func,
 unsigned char offset,unsigned char *val)
 {
-  volatile unsigned char *config_addr, *config_data;
-
-  if (bus>= BSP_MAX_PCI_BUS_ON_PCI0) {
-     bus-=BSP_MAX_PCI_BUS_ON_PCI0;
-     config_addr = (volatile unsigned char*) PCI1_CONFIG_ADDR;
-     config_data = (volatile unsigned char*) PCI1_CONFIG_DATA;
-  }
-  else {
-     config_addr = pci.pci_config_addr;
-     config_data = pci.pci_config_data;
-  }
+  int n=0;
+
+  if (bus>= BSP_MAX_PCI_BUS_ON_PCI0) {
+     bus-=BSP_MAX_PCI_BUS_ON_PCI0;
+     n=1;
+  }
+
   *val = 0xff;
   if (offset & ~0xff) return PCIBIOS_BAD_REGISTER_NUMBER;
 #if 0
-  printk("addr %x, data %x, pack %x \n", config_addr,
-    config_data,pciConfigPack(bus,dev,func,offset));
-#endif
-  outl(pciConfigPack(bus,dev,func,offset),config_addr);
-  *val = inb(config_data + (offset&3));
-  return PCIBIOS_SUCCESSFUL;
-}
-
-static int direct_pci_read_config_word(unsigned char bus, unsigned char dev,
+  printk("addr %x, data %x, pack %x \n", BSP_pci[n].pci_config_addr),
+    BSP_pci[n].config_data,pciConfigPack(bus,dev,func,offset));
+#endif
+
+  out_be32(BSP_pci[n].pci_config_addr, pciConfigPack(bus,dev,func,offset));
+  *val = in_8(BSP_pci[n].pci_config_data + (offset&3));
+  return PCIBIOS_SUCCESSFUL;
+}
+
+static int indirect_pci_read_config_word(unsigned char bus, unsigned char dev,
 unsigned char func, unsigned char offset, unsigned short *val)
 {
-  volatile unsigned char *config_addr, *config_data;
-
-  if (bus>= BSP_MAX_PCI_BUS_ON_PCI0) {
-     bus-=BSP_MAX_PCI_BUS_ON_PCI0;
-     config_addr = (volatile unsigned char*) PCI1_CONFIG_ADDR;
-     config_data = (volatile unsigned char*) PCI1_CONFIG_DATA;
-  }
-  else {
-     config_addr = (volatile unsigned char*) pci.pci_config_addr;
-     config_data = (volatile unsigned char*) pci.pci_config_data;
+  int n=0;
+
+  if (bus>= BSP_MAX_PCI_BUS_ON_PCI0) {
+     bus-=BSP_MAX_PCI_BUS_ON_PCI0;
+     n=1;
   }
 
@@ -122,121 +130,99 @@
     config_data,pciConfigPack(bus,dev,func,offset));
 #endif
-  outl(pciConfigPack(bus,dev,func,offset),config_addr);
-  *val = inw(config_data + (offset&2));
-  return PCIBIOS_SUCCESSFUL;
-}
-
-static int direct_pci_read_config_dword(unsigned char bus, unsigned char dev,
+  out_be32(BSP_pci[n].pci_config_addr, pciConfigPack(bus,dev,func,offset));
+  *val = in_le16(BSP_pci[n].pci_config_data + (offset&2));
+  return PCIBIOS_SUCCESSFUL;
+}
+
+static int indirect_pci_read_config_dword(unsigned char bus, unsigned char dev,
 unsigned char func, unsigned char offset, unsigned int *val) 
 {
-  volatile unsigned char *config_addr, *config_data;
-
-  if (bus>= BSP_MAX_PCI_BUS_ON_PCI0) {
-     bus-=BSP_MAX_PCI_BUS_ON_PCI0;
-     config_addr = (volatile unsigned char*) PCI1_CONFIG_ADDR;
-     config_data = (volatile unsigned char*) PCI1_CONFIG_DATA;
-  }
-  else {
-     config_addr = (volatile unsigned char*) pci.pci_config_addr;
-     config_data = (volatile unsigned char*) pci.pci_config_data;
+  int n=0;
+
+  if (bus>= BSP_MAX_PCI_BUS_ON_PCI0) {
+     bus-=BSP_MAX_PCI_BUS_ON_PCI0;
+     n=1;
   }
 
   *val = 0xffffffff; 
   if ((offset&3)|| (offset & ~0xff)) return PCIBIOS_BAD_REGISTER_NUMBER;
-#if 0
-  printk("addr %x, data %x, pack %x \n", config_addr,
-    pci.pci_config_data,pciConfigPack(bus,dev,func,offset)); 
-#endif
-  outl(pciConfigPack(bus,dev,func,offset),config_addr);
-  *val = inl(config_data);
-  return PCIBIOS_SUCCESSFUL;
-}
-
-static int direct_pci_write_config_byte(unsigned char bus, unsigned char dev,unsigned char func, unsigned char offset, unsigned char val) 
-{
-  volatile unsigned char *config_addr, *config_data;
-
-  if (bus>= BSP_MAX_PCI_BUS_ON_PCI0) {
-     bus-=BSP_MAX_PCI_BUS_ON_PCI0;
-     config_addr = (volatile unsigned char*) PCI1_CONFIG_ADDR;
-     config_data = (volatile unsigned char*) PCI1_CONFIG_DATA;
-  }
-  else {
-     config_addr = pci.pci_config_addr;
-     config_data = pci.pci_config_data;
+
+  out_be32(BSP_pci[n].pci_config_addr, pciConfigPack(bus,dev,func,offset));
+  *val = in_le32(BSP_pci[n].pci_config_data);
+  return PCIBIOS_SUCCESSFUL;
+}
+
+static int indirect_pci_write_config_byte(unsigned char bus, unsigned char dev,unsigned char func, unsigned char offset, unsigned char val) 
+{
+  int n=0;
+
+  if (bus>= BSP_MAX_PCI_BUS_ON_PCI0) {
+     bus-=BSP_MAX_PCI_BUS_ON_PCI0;
+     n=1;
   }
 
   if (offset & ~0xff) return PCIBIOS_BAD_REGISTER_NUMBER;
-#if 0
-  printk("addr %x, data %x, pack %x \n", config_addr,
-    config_data,pciConfigPack(bus,dev,func,offset));
-#endif
-
-  outl(pciConfigPack(bus,dev,func,offset), config_addr);
-  outb(val, config_data + (offset&3));
-  return PCIBIOS_SUCCESSFUL;
-}
-
-static int direct_pci_write_config_word(unsigned char bus, unsigned char dev,unsigned char func, unsigned char offset, unsigned short val) 
-{
-  volatile unsigned char *config_addr, *config_data;
-
-  if (bus>= BSP_MAX_PCI_BUS_ON_PCI0) {
-     bus-=BSP_MAX_PCI_BUS_ON_PCI0;
-     config_addr = (volatile unsigned char*) PCI1_CONFIG_ADDR;
-     config_data = (volatile unsigned char*) PCI1_CONFIG_DATA;
-  }
-  else {
-     config_addr = (volatile unsigned char*) pci.pci_config_addr;
-     config_data = (volatile unsigned char*) pci.pci_config_data;
+
+  out_be32(BSP_pci[n].pci_config_addr, pciConfigPack(bus,dev,func,offset));
+  out_8(BSP_pci[n].pci_config_data + (offset&3), val);
+  return PCIBIOS_SUCCESSFUL;
+}
+
+static int indirect_pci_write_config_word(unsigned char bus, unsigned char dev,unsigned char func, unsigned char offset, unsigned short val) 
+{
+  int n=0;
+
+  if (bus>= BSP_MAX_PCI_BUS_ON_PCI0) {
+     bus-=BSP_MAX_PCI_BUS_ON_PCI0;
+     n=1;
   }
 
   if ((offset&1)|| (offset & ~0xff)) return PCIBIOS_BAD_REGISTER_NUMBER;
-#if 0
-  printk("addr %x, data %x, pack %x \n", config_addr,
-    config_data,pciConfigPack(bus,dev,func,offset));
-#endif
-  outl(pciConfigPack(bus,dev,func,offset),config_addr);
-  outw(val, config_data + (offset&3));
-  return PCIBIOS_SUCCESSFUL;
-}
-
-static int direct_pci_write_config_dword(unsigned char bus,unsigned char dev,unsigned char func, unsigned char offset, unsigned int val) 
-{
-  volatile unsigned char *config_addr, *config_data;
-
-  if (bus>= BSP_MAX_PCI_BUS_ON_PCI0) {
-     bus-=BSP_MAX_PCI_BUS_ON_PCI0;
-     config_addr = (volatile unsigned char *) PCI1_CONFIG_ADDR;
-     config_data = (volatile unsigned char *) PCI1_CONFIG_DATA;
-  }
-  else {
-     config_addr = (volatile unsigned char*) pci.pci_config_addr;
-     config_data = (volatile unsigned char*) pci.pci_config_data;
+
+  out_be32(BSP_pci[n].pci_config_addr, pciConfigPack(bus,dev,func,offset));
+  out_le16(BSP_pci[n].pci_config_data + (offset&3), val);
+  return PCIBIOS_SUCCESSFUL;
+}
+
+static int indirect_pci_write_config_dword(unsigned char bus,unsigned char dev,unsigned char func, unsigned char offset, unsigned int val) 
+{
+  int n=0;
+
+  if (bus>= BSP_MAX_PCI_BUS_ON_PCI0) {
+     bus-=BSP_MAX_PCI_BUS_ON_PCI0;
+     n=1;
   }
 
   if ((offset&3)|| (offset & ~0xff)) return PCIBIOS_BAD_REGISTER_NUMBER;
-#if 0
-  printk("addr %x, data %x, pack %x \n", config_addr,
-    config_data,pciConfigPack(bus,dev,func,offset));
-#endif
-  outl(pciConfigPack(bus,dev,func,offset),config_addr);
-  outl(val,config_data);
-  return PCIBIOS_SUCCESSFUL;
-}
-
-const pci_config_access_functions pci_direct_functions = {
-  	direct_pci_read_config_byte,
-  	direct_pci_read_config_word,
-  	direct_pci_read_config_dword,
-  	direct_pci_write_config_byte,
-  	direct_pci_write_config_word,
-  	direct_pci_write_config_dword
+
+  out_be32(BSP_pci[n].pci_config_addr, pciConfigPack(bus,dev,func,offset));
+  out_le32(BSP_pci[n].pci_config_data, val);
+  return PCIBIOS_SUCCESSFUL;
+}
+
+const pci_config_access_functions pci_indirect_functions = {
+  	indirect_pci_read_config_byte,
+  	indirect_pci_read_config_word,
+  	indirect_pci_read_config_dword,
+  	indirect_pci_write_config_byte,
+  	indirect_pci_write_config_word,
+  	indirect_pci_write_config_dword
 };
 
 
-pci_config BSP_pci_configuration = {(volatile unsigned char*) PCI_CONFIG_ADDR,
-			 (volatile unsigned char*)PCI_CONFIG_DATA,
-				    &pci_direct_functions};
+pci_config BSP_pci_configuration = {
+           (volatile unsigned char*) (GT64x60_PCI_CONFIG_ADDR),
+	   (volatile unsigned char*) (GT64x60_PCI_CONFIG_DATA),
+	   &pci_indirect_functions};
+
+DiscoveryChipVersion BSP_getDiscoveryChipVersion()
+{
+  return(BSP_sysControllerVersion);
+}
+
+BSP_VMEchipTypes BSP_getVMEchipType()
+{
+  return(BSP_VMEinterface);
+}
 
 /*
@@ -249,10 +235,10 @@
 {
   int deviceFound;
-  unsigned char ucBusNumber, ucSlotNumber, ucFnNumber, ucNumFuncs;
-  unsigned int ulHeader;
-  unsigned int pcidata, ulClass, ulDeviceID;
-
-  pci_interface();
-  
+  unsigned char ucBusNumber, ucSlotNumber, ucFnNumber, ucNumFuncs, data8;
+  uint32_t ulHeader, ulClass, ulDeviceID;
+#if PCI_DEBUG
+  uint32_t pcidata;
+#endif
+
   /*
    * Scan PCI0 and PCI1 buses
@@ -280,10 +266,34 @@
       switch(ulDeviceID) { 
         case (PCI_VENDOR_ID_MARVELL+(PCI_DEVICE_ID_MARVELL_GT6426xAB<<16)):
-#if PCI_PRINT
-	  printk("Marvell GT6426xA/B hostbridge detected at bus%d slot%d\n",
+          pci_read_config_byte(0,0,0,PCI_REVISION_ID, &data8);
+          switch(data8) {
+	  case 0x10:
+	    BSP_sysControllerVersion = GT64260A;
+#if PCI_PRINT
+	    printk("Marvell GT64260A (Discovery I) hostbridge detected at bus%d slot%d\n",
+                 ucBusNumber,ucSlotNumber);
+#endif
+	    break;
+          case 0x20:
+	    BSP_sysControllerVersion = GT64260B;
+#if PCI_PRINT
+	    printk("Marvell GT64260B (Discovery I) hostbridge detected at bus%d slot%d\n",
+                 ucBusNumber,ucSlotNumber);
+#endif
+	    break;
+	  default:
+	    printk("Undefined revsion of GT64260 chip\n");
+            break;
+          }
+	  break;
+        case (PCI_VENDOR_ID_MARVELL+(PCI_DEVICE_ID_MARVELL_GT64360<<16)):
+	  BSP_sysControllerVersion = MV64360;
+#if PCI_PRINT
+	  printk("Marvell GT64360 (Discovery II) hostbridge detected at bus%d slot%d\n",
                  ucBusNumber,ucSlotNumber);
 #endif
 	  break;
         case (PCI_VENDOR_ID_PLX2+(PCI_DEVICE_ID_PLX2_PCI6154_HB2<<16)):
+	  BSP_VMEinterface = UNIVERSE2;
 #if PCI_PRINT
           printk("PLX PCI6154 PCI-PCI bridge detected at bus%d slot%d\n",
@@ -297,4 +307,11 @@
 #endif
           break;
+        case (PCI_VENDOR_ID_TUNDRA+(PCI_DEVICE_ID_TUNDRA_TSI148<<16)):
+	  BSP_VMEinterface = TSI148;
+#if PCI_PRINT
+          printk("TUNDRA Tsi148 PCI/X-VME bridge detected at bus%d slot%d\n",
+                 ucBusNumber,ucSlotNumber);
+#endif
+          break;
       case (PCI_VENDOR_ID_INTEL+(PCI_DEVICE_INTEL_82544EI_COPPER<<16)):
 #if PCI_PRINT
@@ -304,5 +321,5 @@
           break;
       case (PCI_VENDOR_ID_DEC+(PCI_DEVICE_ID_DEC_21150<<16)):
- #if PCI_PRINT
+#if PCI_PRINT
           printk("DEC21150 PCI-PCI bridge detected at bus%d slot%d\n",
                  ucBusNumber,ucSlotNumber);
@@ -310,6 +327,13 @@
 	  break;
        default : 
+#if PCI_PRINT
           printk("BSP unlisted vendor, Bus%d Slot%d DeviceID 0x%x \n",
              ucBusNumber,ucSlotNumber, ulDeviceID);
+#endif
+	  /* Kate Feng : device not supported by BSP needs to remap the IRQ line on mvme5500/mvme6100 */
+          pci_read_config_byte(ucBusNumber,ucSlotNumber,0,PCI_INTERRUPT_LINE,&data8);
+	  if (data8 < BSP_GPP_IRQ_LOWEST_OFFSET)  pci_write_config_byte(ucBusNumber,
+ 	     ucSlotNumber,0,PCI_INTERRUPT_LINE,BSP_GPP_IRQ_LOWEST_OFFSET+data8);
+
           break;
       }
@@ -404,32 +428,4 @@
 
       }
-
-      pci_read_config_dword(ucBusNumber,
-			       ucSlotNumber,
-			       0,
-			  PCI_COMMAND,
-                          &pcidata); 
-#if PCI_DEBUG
-      printk("MOTLoad command staus 0x%x, ", pcidata);
-#endif
-      /* Clear the error on the host bridge */
-      if ( (ucBusNumber==0) && (ucSlotNumber==0))
-	pcidata |= PCI_STATUS_CLRERR_MASK;
-      /* Enable bus,I/O and memory master access. */
-      pcidata |= (PCI_COMMAND_MASTER|PCI_COMMAND_IO|PCI_COMMAND_MEMORY);
-      pci_write_config_dword(ucBusNumber,
- 			       ucSlotNumber,
-			       0,
-			  PCI_COMMAND,
-                          pcidata);
-
-      pci_read_config_dword(ucBusNumber,
-			       ucSlotNumber,
-			       0,
-			  PCI_COMMAND,
-                          &pcidata); 
-#if PCI_DEBUG      
-      printk("Now command/staus 0x%x\n", pcidata);
-#endif
     }
     if (deviceFound) ucMaxPCIBus++;
@@ -439,4 +435,5 @@
 	 pci_bus_count(), numPCIDevs);
 #endif
+  pci_interface(BSP_sysControllerVersion); 
   return(0);
 }
Index: c/src/lib/libbsp/powerpc/mvme5500/pci/pci.h
===================================================================
--- c/src/lib/libbsp/powerpc/mvme5500/pci/pci.h	(revision e1be2b30ad3b43c28cba087614a6ebca6356445e)
+++ c/src/lib/libbsp/powerpc/mvme5500/pci/pci.h	(revision d7196bfd6696be61880fff7db8ca4de044c30748)
@@ -15,6 +15,5 @@
  *      pci.h,v 1.2 2002/05/14 17:10:16 joel Exp
  *
- *      S. Kate Feng : Added support for Marvell and PLX. 3/5/2004.
-
+ *      S. Kate Feng : Added support for Marvell and PLX. 2004, 2007.
  */
 
@@ -24,8 +23,9 @@
 #include <rtems/pci.h>
 
-#define PCI_CAPABILITY_LIST_POINTER    0x34  /* <SKF> */
+/************   Beginning of added by Kate Feng **********************/
+#define PCI_CAPABILITY_LIST_POINTER    0x34
 
 /* Device classes and subclasses */
-#define PCI_CLASS_GT6426xAB_BRIDGE_PCI  0x0580    /* <SKF> */
+#define PCI_CLASS_GT6426xAB_BRIDGE_PCI  0x0580 
           
 /*
@@ -34,14 +34,18 @@
  * <linux-pcisupport@cck.uni-kl.de>.
  */
-#define PCI_VENDOR_ID_MARVELL           0x11ab   /* <SKF> */
-#define PCI_DEVICE_ID_MARVELL_GT6426xAB 0x6430   /* <SKF> */
+#define PCI_VENDOR_ID_MARVELL           0x11ab  
+#define PCI_DEVICE_ID_MARVELL_GT6426xAB 0x6430   
+#define PCI_DEVICE_ID_MARVELL_GT64360   0x6460  
 
 /* Note : The PLX Technology Inc. had the old VENDOR_ID.
  * See PCI_VENDOR_ID_PLX,  PCI_VENDOR_ID_PLX_9050, ..etc.
  */
-#define PCI_VENDOR_ID_PLX2              0x3388   /* <SKF> */
-#define PCI_DEVICE_ID_PLX2_PCI6154_HB2  0x26     /* <SKF> */
+#define PCI_VENDOR_ID_PLX2              0x3388   
+#define PCI_DEVICE_ID_PLX2_PCI6154_HB2  0x26     
 
-#define PCI_DEVICE_INTEL_82544EI_COPPER	0x1008	/* <SKF> */
+#define PCI_DEVICE_ID_TUNDRA_TSI148     0x0148  
+#define PCI_DEVICE_INTEL_82544EI_COPPER	0x1008
+
+/* end of added by Kate Feng */
 
 struct _pin_routes
Index: c/src/lib/libbsp/powerpc/mvme5500/pci/pci_interface.c
===================================================================
--- c/src/lib/libbsp/powerpc/mvme5500/pci/pci_interface.c	(revision e1be2b30ad3b43c28cba087614a6ebca6356445e)
+++ c/src/lib/libbsp/powerpc/mvme5500/pci/pci_interface.c	(revision d7196bfd6696be61880fff7db8ca4de044c30748)
@@ -8,8 +8,12 @@
  *
  * 8/17/2006 : S. Kate Feng
- *             uses in_le32()/out_le32(), instead of inl()/outl() so that
- *             it is easier to be ported.
+ *             uses in_le32()/out_le32(), instead of inl()/outl() for compatibility.
  *
+ * 11/2008 : Enable "PCI Read Agressive Prefetch", 
+ *           "PCI Read Line Agressive Prefetch", and
+ *           "PCI Read Multiple Agressive Prefetch" to improve the
+ *           performance of the PCI based applications (e.g. 1GHz NIC).
  */
+
 #include <libcpu/io.h>
 #include <rtems/bspIo.h>	    /* printk */
@@ -20,40 +24,21 @@
 #include <bsp/gtpcireg.h> 
 
-#define REG32_READ(reg) in_le32((volatile unsigned int *)(GT64260_REG_BASE+reg))
-#define REG32_WRITE(data, reg) out_le32((volatile unsigned int *)(GT64260_REG_BASE+reg), data)
-
 #define PCI_DEBUG     0
 
-/* Please reference the GT64260B datasheet, for the PCI interface, 
- * Synchronization Barriers and PCI ordering.
- *
- * Some PCI devices require Synchronization Barriers or PCI ordering
- * for synchronization (only one mechanism allowed. See section 11.1.2).
- * To use the former mechanism(default), one needs to call 
- * CPU0_PciEnhanceSync() or CPU1_PciEnhanceSync() to perform software
- * synchronization between the CPU and PCI activities.
- * 
- * To use the PCI-ordering, one can call pciToCpuSync() to trigger
- * the PCI-to-CPU sync barrier after the out_xx(). In this mode,
- * PCI configuration reads suffer sync barrier latency. Please reference
- * the datasheet to explore other options.
- *
- * Note : If PCI_ORDERING is needed for the PCI0, while disabling the
- * deadlock  for the PCI0, one should keep the CommDLEn bit enabled
- * for the deadlock mechanism so that the 10/100 MB ethernet will
- * function correctly.
- *
+#if 0
+#define CPU2PCI_ORDER
+#define PCI2CPU_ORDER
+#endif
+
+/* PCI Read Agressive Prefetch Enable (1<<16 ),
+ * PCI Read Line Agressive Prefetch Enable( 1<<17),
+ * PCI Read Multiple Agressive Prefetch Enable (1<<18).
  */
-/*#define PCI_ORDERING*/
+#ifdef PCI2CPU_ORDER
+#define PCI_ACCCTLBASEL_VALUE          0x01079000
+#else
+#define PCI_ACCCTLBASEL_VALUE          0x01071000 
+#endif
 
-#define EN_SYN_BAR   /* take MOTLoad default for enhanced SYN Barrier mode */
-
-/*#define PCI_DEADLOCK*/
-
-#ifdef PCI_ORDERING
-#define PCI_ACCCTLBASEL_VALUE          0x01009000
-#else
-#define PCI_ACCCTLBASEL_VALUE          0x01001000
-#endif
 
 #define ConfSBDis     0x10000000  /* 1: disable, 0: enable */
@@ -61,11 +46,4 @@
 #define ConfIOSBDis   0x30000000
 #define CpuPipeline   0x00002000  /* optional, 1:enable, 0:disable */
-
-#define CPU0_SYNC_TRIGGER   0xD0  /* CPU0 Sync Barrier trigger */
-#define CPU0_SYNC_VIRTUAL   0xC0  /* CPU0 Sync Barrier Virtual */
-
-#define CPU1_SYNC_TRIGGER   0xD8  /* CPU1 Sync Barrier trigger */
-#define CPU1_SYNC_VIRTUAL   0xC8  /* CPU1 Sync Barrier Virtual */
-
 
 /* CPU to PCI ordering register */
@@ -87,73 +65,34 @@
 #define ADDR_PIPELINE 0x00020000
 
-void  pciAccessInit();
+void  pciAccessInit(void);
 
-void pci_interface()
+void pci_interface(void)
 {
 
-#ifdef PCI_DEADLOCK
-  REG32_WRITE(0x07fff600, CNT_SYNC_REG);
+#ifdef CPU2PCI_ORDER
+    /* MOTLOad deafult : 0x07ff8600 */
+    out_le32((volatile unsigned int *)(GT64x60_REG_BASE+CNT_SYNC_REG), 0x07fff600);
 #endif
-#ifdef PCI_ORDERING
-  /* Let's leave this to be MOTLOad deafult : 0x80070000 
-     REG32_WRITE(0xc0070000, DLOCK_ORDER_REG);*/
-  /* Leave the CNT_SYNC_REG b/c MOTload default had the SyncBarMode set to 1 */
-#endif
+    /* asserts SERR upon various detection */
+    out_le32((volatile unsigned int *)(GT64x60_REG_BASE+0xc28), 0x3fffff);
+    pciAccessInit();
+}
 
-  /* asserts SERR upon various detection */
-  REG32_WRITE(0x3fffff, 0xc28);
-
-  pciAccessInit();
-}
-/* Use MOTLoad default for Writeback Priority and Buffer Depth 
- */
-void pciAccessInit()
+void pciAccessInit(void)
 {
   unsigned int PciLocal, data;
 
   for (PciLocal=0; PciLocal < 2; PciLocal++) {
-    /* MOTLoad combines the two banks of SDRAM into
-     * one PCI access control because the top = 0x1ff
-     */
-    data = REG32_READ(GT_SCS0_Low_Decode) & 0xfff; 
+    data = in_le32((volatile unsigned int *)(GT64x60_REG_BASE+PCI0_ACCESS_CNTL_BASE0_LOW+(PciLocal * 0x80)));
+#if 0
+    printk("PCI%d_ACCESS_CNTL_BASE0_LOW was 0x%x\n",PciLocal,data);
+#endif 
     data |= PCI_ACCCTLBASEL_VALUE;
     data &= ~0x300000;
-    REG32_WRITE(data, PCI0_ACCESS_CNTL_BASE0_LOW+(PciLocal * 0x80));
-#if PCI_DEBUG
-    printk("PCI%d_ACCESS_CNTL_BASE0_LOW 0x%x\n",PciLocal,REG32_READ(PCI_ACCESS_CNTL_BASE0_LOW+(PciLocal * 0x80))); 
+    out_le32((volatile unsigned int *)(GT64x60_REG_BASE+PCI0_ACCESS_CNTL_BASE0_LOW+(PciLocal * 0x80)), data);
+#if 0
+      printf("PCI%d_ACCESS_CNTL_BASE0_LOW now 0x%x\n",PciLocal,in_le32((volatile unsigned int *)(GT64x60_REG_BASE+PCI0_ACCESS_CNTL_BASE0_LOW+(PciLocal * 0x80)))); 
 #endif
-
   }
 }
 
-/* Sync Barrier Trigger. A write to the CPU_SYNC_TRIGGER register triggers
- * the sync barrier process.  The three bits, define which buffers should
- * be flushed.
- * Bit 0 = PCI0 slave write buffer.
- * Bit 1 = PCI1 slave write buffer.
- * Bit 2 = SDRAM snoop queue.
- */
-void CPU0_PciEnhanceSync(unsigned int syncVal)
-{
-  REG32_WRITE(syncVal,CPU0_SYNC_TRIGGER);
-  while (REG32_READ(CPU0_SYNC_VIRTUAL));
-}
-
-void CPU1_PciEnhanceSync(unsigned int syncVal)
-{
-  REG32_WRITE(syncVal,CPU1_SYNC_TRIGGER);
-  while (REG32_READ(CPU1_SYNC_VIRTUAL));
-}
-
-/* Currently, if PCI_ordering is used for synchronization, configuration
- * reads is programmed to be the PCI slave "synchronization barrier" 
- * cycles. 
- */
-void pciToCpuSync(int pci_num)
-{
-  unsigned char data;
-  unsigned char bus=0;
-
-  if (pci_num) bus += BSP_MAX_PCI_BUS_ON_PCI0;
-  pci_read_config_byte(bus,0,0,4, &data);
-}
Index: c/src/lib/libbsp/powerpc/mvme5500/pci/pcifinddevice.c
===================================================================
--- c/src/lib/libbsp/powerpc/mvme5500/pci/pcifinddevice.c	(revision e1be2b30ad3b43c28cba087614a6ebca6356445e)
+++ c/src/lib/libbsp/powerpc/mvme5500/pci/pcifinddevice.c	(revision d7196bfd6696be61880fff7db8ca4de044c30748)
@@ -8,5 +8,5 @@
  * 
  * Kate Feng <feng1@bnl.gov>, modified it to support the mvme5500 board.
- * 
+ * Under the Deaprtment of Energy contract DE-AC02-98CH10886.
  */
 
Index: c/src/lib/libbsp/powerpc/mvme5500/startup/bspclean.c
===================================================================
--- c/src/lib/libbsp/powerpc/mvme5500/startup/bspclean.c	(revision e1be2b30ad3b43c28cba087614a6ebca6356445e)
+++ c/src/lib/libbsp/powerpc/mvme5500/startup/bspclean.c	(revision d7196bfd6696be61880fff7db8ca4de044c30748)
@@ -1,2 +1,5 @@
+/* Copyright 2003, Shuchen Kate Feng <feng1@bnl.gov>,
+ *                    NSLS,Brookhaven National Laboratory
+ */
 #include <bsp.h>
 #include <rtems/bspIo.h>
Index: c/src/lib/libbsp/powerpc/mvme5500/startup/bspstart.c
===================================================================
--- c/src/lib/libbsp/powerpc/mvme5500/startup/bspstart.c	(revision e1be2b30ad3b43c28cba087614a6ebca6356445e)
+++ c/src/lib/libbsp/powerpc/mvme5500/startup/bspstart.c	(revision d7196bfd6696be61880fff7db8ca4de044c30748)
@@ -18,8 +18,7 @@
  *  (C) by Till Straumann, <strauman@slac.stanford.edu>, 2002, 2004, 2005
  *
- *  Modified to support the MVME5500 board.
- *  Also, the settings of L1, L2, and L3 caches is not necessary here.
- *  (C) by Brookhaven National Lab., S. Kate Feng <feng1@bnl.gov>, 2003, 2004, 2005
- *  
+ *  Modified to support the mvme5500 BSP 
+ *  (C) S. Kate Feng,Brookhaven National Lab <feng1@bnl.gov>, 2003, 2004, 2005, 2008
+ *
  *  $Id$
  */
@@ -43,4 +42,5 @@
 #include <bsp/vectors.h>
 #include <bsp/bspException.h>
+#include <bsp/VPD.h>
 
 #include <rtems/bspIo.h>
@@ -51,6 +51,5 @@
 #endif
 
-/*
-#define SHOW_MORE_INIT_SETTINGS
+/*efine SHOW_MORE_INIT_SETTINGS
 #define SHOW_LCR1_REGISTER
 #define SHOW_LCR2_REGISTER
@@ -75,4 +74,5 @@
 SPR_RW(SPRG0)
 SPR_RW(SPRG1)
+extern uint32_t probeMemoryEnd();
 
 typedef struct CmdLineRec_ {
@@ -96,4 +96,8 @@
 #define MAX_LOADER_ADD_PARM 80
 char loaderParam[MAX_LOADER_ADD_PARM];
+
+BSP_BoardTypes BSP_boardType=0;
+
+DiscoveryChipVersion BSP_controller_version;
 
 /*
@@ -223,4 +227,9 @@
 }
 
+BSP_BoardTypes BSP_getBoardType()
+{
+	return BSP_boardType;
+}
+
 /*
  *  bsp_start
@@ -234,4 +243,5 @@
   int i;
 #endif
+  int x;
   unsigned char *stack;
   unsigned long	 *r1sp;
@@ -251,4 +261,6 @@
   ppc_cpu_revision_t myCpuRevision;
   Triv121PgTbl	pt=0;
+  ConfVpdRec_t *pVPD = (ConfVpdRec_t *) &ConfVPD_buff[0];
+
 
   /* Till Straumann: 4/2005
@@ -261,10 +273,9 @@
   setdbat(2, PCI0_MEM_BASE, PCI0_MEM_BASE, 0x10000000, IO_PAGE);
 
-  /* Till Straumann: 2004
-   * map the PCI 0, 1 Domain I/O space, GT64260B registers
-   * and the reserved area so that the size is the power of 2.
+  /* map the PCI 0, 1 Domain I/O space, GT64260B registers,
+   * Flash Bank 0 and Flash Bank 2.
    * 
    */
-  setdbat(3,PCI0_IO_BASE, PCI0_IO_BASE, 0x2000000, IO_PAGE);
+  setdbat(3,PCI0_IO_BASE, PCI0_IO_BASE, 0x10000000, IO_PAGE);
 
 
@@ -323,4 +334,21 @@
   Cpu_table.exceptions_in_RAM = TRUE;
   initialize_exceptions();
+
+  /* <SKF> pci_initialize() before BSP_rtems_irq_mng_init to identify the version of the
+   * Discovery chip.
+   */
+#ifdef SHOW_MORE_INIT_SETTINGS
+  printk("Going to start PCI buses scanning and initialization\n");
+#endif  
+  pci_initialize();
+#ifdef SHOW_MORE_INIT_SETTINGS
+  printk("Number of PCI buses found is : %d\n", pci_bus_count());
+#endif
+
+  /*
+   * Initalize RTEMS IRQ system
+   */
+  BSP_rtems_irq_mng_init(0);
+
   /*
    * Init MMU block address translation to enable hardware
@@ -329,31 +357,8 @@
    */
   printk("-----------------------------------------\n");
-  printk("Welcome to %s on MVME5500-0163\n", _RTEMS_version );
+  printk("Welcome to %s on MVME5500\n", _RTEMS_version );
   printk("-----------------------------------------\n");
 
-#ifdef TEST_RETURN_TO_PPCBUG  
-  printk("Hit <Enter> to return to PPCBUG monitor\n");
-  printk("When Finished hit GO. It should print <Back from monitor>\n");
-  debug_getc();
-  _return_to_ppcbug();
-  printk("Back from monitor\n");
-  _return_to_ppcbug();
-#endif /* TEST_RETURN_TO_PPCBUG  */
-
-#ifdef TEST_RAW_EXCEPTION_CODE  
-  printk("Testing exception handling Part 1\n");
-  /*
-   * Cause a software exception
-   */
-  __asm__ __volatile ("sc");
-  /*
-   * Check we can still catch exceptions and returned coorectly.
-   */
-  printk("Testing exception handling Part 2\n");
-  __asm__ __volatile ("sc");
-#endif  
-
-  BSP_mem_size 				=  _512M;
-  /* TODO: calculate the BSP_bus_frequency using the REF_CLK bit of System Status  register */
+  BSP_mem_size 				=  probeMemoryEnd();
   /* rtems_bsp_delay_in_bus_cycles are defined in registers.h */
   BSP_bus_frequency			= 133333333;
@@ -402,9 +407,4 @@
   BSP_Configuration.work_space_start = work_space_start;
 
-  /*
-   * Initalize RTEMS IRQ system
-   */
-   BSP_rtems_irq_mng_init(0);
-
 #ifdef SHOW_LCR2_REGISTER
   l2cr = get_L2CR();
@@ -430,28 +430,5 @@
   }
 
-  /*
-   * PCI 1 domain memory space
-   */
-  setdbat(1, PCI1_MEM_BASE, PCI1_MEM_BASE, 0x10000000, IO_PAGE);
- 
-
-#ifdef SHOW_MORE_INIT_SETTINGS
-  printk("Going to start PCI buses scanning and initialization\n");
-#endif  
-  pci_initialize();
-#ifdef SHOW_MORE_INIT_SETTINGS
-  printk("Number of PCI buses found is : %d\n", pci_bus_count());
-#endif
-
-  /* Install our own exception handler (needs PCI) */
-  globalExceptHdl = BSP_exceptionHandler;
-
-  /* clear hostbridge errors. MCP signal is not used on the MVME5500
-   * PCI config space scanning code will trip otherwise :-(
-   */
-  _BSP_clear_hostbridge_errors(0, 1 /*quiet*/);
-
-  /* Read Configuration Vital Product Data (VPD) */
-  if ( I2Cread_eeprom(0xa8, 4,2, &ConfVPD_buff[0], 150))
+  if ( I2Cread_eeprom(0xa8, 0,2, (void *) pVPD, sizeof(ConfVpdRec_t)))
      printk("I2Cread_eeprom() error \n");
   else {
@@ -462,7 +439,22 @@
       if ((i % 20)==0 ) printk("\n");
     }
-    printk("\n");
 #endif
   }
+
+  /*
+   * PCI 1 domain memory space
+   */
+  setdbat(1, PCI1_MEM_BASE, PCI1_MEM_BASE, 0x10000000, IO_PAGE);
+ 
+  /* Install our own exception handler (needs PCI) */
+  globalExceptHdl = BSP_exceptionHandler;
+
+
+#if 1
+  /* clear hostbridge errors. MCP signal is not used on the MVME5500
+   * PCI config space scanning code will trip otherwise :-(
+   */
+  _BSP_clear_hostbridge_errors(0, 1 /*quiet*/);
+#endif
 
 #ifdef SHOW_MORE_INIT_SETTINGS
@@ -470,4 +462,3 @@
   printk("Exit from bspstart\n");
 #endif
-
-}
+}
Index: c/src/lib/libbsp/powerpc/mvme5500/startup/pgtbl_activate.c
===================================================================
--- c/src/lib/libbsp/powerpc/mvme5500/startup/pgtbl_activate.c	(revision e1be2b30ad3b43c28cba087614a6ebca6356445e)
+++ c/src/lib/libbsp/powerpc/mvme5500/startup/pgtbl_activate.c	(revision d7196bfd6696be61880fff7db8ca4de044c30748)
@@ -12,4 +12,5 @@
 /* Author: Till Straumann, <strauman@slac.stanford.edu>, 4/2002 
  * Kate Feng <feng1@bnl.gov> ported it to MVME5500, 4/2004
+ *
  */
 
Index: c/src/lib/libbsp/powerpc/mvme5500/startup/reboot.c
===================================================================
--- c/src/lib/libbsp/powerpc/mvme5500/startup/reboot.c	(revision e1be2b30ad3b43c28cba087614a6ebca6356445e)
+++ c/src/lib/libbsp/powerpc/mvme5500/startup/reboot.c	(revision d7196bfd6696be61880fff7db8ca4de044c30748)
@@ -1,2 +1,8 @@
+/* Copyright 2003, Shuchen Kate Feng <feng1@bnl.gov>,
+ *                    NSLS,Brookhaven National Laboratory
+ *
+ * Ported it from powerpc/shared/console/reboot.c for mvme5500
+ *
+ */
 #include <rtems.h>
 #include <bsp.h>
@@ -13,4 +19,4 @@
   printk("RTEMS terminated; Rebooting ...\n");
   /* Mvme5500 board reset : 2004 S. Kate Feng <feng1@bnl.gov>  */
-  out_8((volatile unsigned char*) (GT64260_DEV1_BASE +2), 0x80);
+  out_8((volatile unsigned char*) (GT64x60_DEV1_BASE +2), 0x80);
 }
